package netbank.firm.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CpuUtil {

   private static Logger log = LoggerFactory.getLogger(CpuUtil.class);
   private static String cpuID = "";


   public static String getCupId() {
      String property = System.getProperty("os.name");
      if(property.contains("Window")) {
         log.info("OS name is Windows.");
         if(StringUtils.isBlank(cpuID)) {
            try {
               File e = File.createTempFile("getCpuId", ".vbs");
               e.deleteOnExit();
               FileWriter writer = new FileWriter(e);
               String vbs = "Set objWMIService = GetObject(\"winmgmts:\\\\.\\root\\cimv2\")\nSet colItems = objWMIService.ExecQuery _ \n (\"Select * from Win32_Processor\") \nFor Each objItem in colItems \n Wscript.Echo objItem.ProcessorId \n exit for \'do the first cpu only! \n Next \n";
               writer.write(vbs);
               writer.close();
               String path = e.getPath().replace("%20", "");
               Process process = Runtime.getRuntime().exec("cscript //NoLogo " + path);

               BufferedReader reader;
               String line;
               for(reader = new BufferedReader(new InputStreamReader(process.getInputStream())); (line = reader.readLine()) != null; cpuID = cpuID + line) {
                  ;
               }

               reader.close();
               e.deleteOnExit();
            } catch (IOException var9) {
               log.info("Can not get CPUID: " + var9.getMessage());
            }
         }
      } else if(property.contains("Linux")) {
         log.info("OS name is Linux.");

         try {
            cpuID = getCpuIdforLinux();
         } catch (IOException var8) {
            log.info("Can not get CPUID: Permission Denied!");
            cpuID = "No_Permission";
         }
      } else {
         log.info("OS name is " + property);
         cpuID = "(" + property + ")Cpuid_not_acquired.";
      }

      return cpuID;
   }

   public static String getCpuIdforLinux() throws IOException {
      String result = "";
      String[] linuxCommand = new String[]{"dmidecode", "-t", "processor", "|", "grep", "ID"};
      BufferedReader bufferedReader = null;
      Process p = null;
      p = Runtime.getRuntime().exec(linuxCommand);
      bufferedReader = new BufferedReader(new InputStreamReader(p.getInputStream()));
      String line = null;
      boolean index = true;

      while((line = bufferedReader.readLine()) != null) {
         int index1 = line.indexOf("ID");
         if(index1 >= 0) {
            result = line.substring(index1 + "ID".length() + 1).trim();
            break;
         }
      }

      return StringUtils.isBlank(result)?"No_Permission":result.replace(" ", "");
   }

   public static void main(String[] args) {
      String p = "";

      try {
         p = getCpuIdforLinux();
      } catch (IOException var3) {
         ;
      }

      System.out.println(p);
   }

}
